Index: LMDZ5/trunk/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/phys_output_write_mod.F90	(revision 2179)
+++ LMDZ5/trunk/libf/phylmd/phys_output_write_mod.F90	(revision 2180)
@@ -228,5 +228,5 @@
     USE ocean_slab_mod, only: tslab, slab_bils
     USE indice_sol_mod, only: nbsrf
-    USE infotrac, only: nqtot, nqo
+    USE infotrac, only: nqtot, nqo, type_trac
     USE comgeomphy, only: airephy
     USE surface_data, only: type_ocean, ok_veget, ok_snow
@@ -1323,4 +1323,5 @@
         IF (nqtot.GE.nqo+1) THEN
             DO iq=nqo+1,nqtot
+              IF (type_trac == 'lmdz' .OR. type_trac == 'repr') THEN
 
              CALL histwrite_phy(o_trac(iq-nqo), qx(:,:,iq))
@@ -1345,4 +1346,5 @@
              ENDIF
              CALL histwrite_phy(o_trac_cum(iq-nqo), zx_tmp_fi2d)
+             endif
           ENDDO
        ENDIF
Index: LMDZ5/trunk/libf/phylmd/physiq.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/physiq.F90	(revision 2179)
+++ LMDZ5/trunk/libf/phylmd/physiq.F90	(revision 2180)
@@ -1308,5 +1308,7 @@
              annee_ref, &
              day_ref,  &
-             itau_phy)
+             itau_phy, &
+             io_lon, &
+             io_lat)
 
         CALL VTe(VTinca)
Index: LMDZ5/trunk/libf/phylmd/phytrac_mod.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/phytrac_mod.F90	(revision 2179)
+++ LMDZ5/trunk/libf/phylmd/phytrac_mod.F90	(revision 2180)
@@ -308,5 +308,4 @@
 !$OMP THREADPRIVATE(lessivage)
 
-    CHARACTER(len=8),DIMENSION(nbtr) :: solsym
     !RomP >>>
     INTEGER,SAVE  :: iflag_lscav_omp,iflag_lscav
@@ -557,5 +556,5 @@
             cdragh,  coefh, yu1, yv1, ftsol, pctsrf, xlat, xlon,iflag_vdf_trac>=0,sh, &
             rh, pphi, ustar, wstar, ale_bl, ale_wake,  u10m, v10m, &
-            tr_seri, source, solsym, d_tr_cl,d_tr_dec, zmasse)               !RomP
+            tr_seri, source, d_tr_cl,d_tr_dec, zmasse)               !RomP
 
     CASE('inca')
@@ -572,5 +571,5 @@
             tau_aero, piz_aero, cg_aero,        ccm,       &
             rfname,                                        &
-            tr_seri,  source,   solsym)      
+            tr_seri,  source)      
 
     CASE('repr')
@@ -580,5 +579,5 @@
             presnivs, xlat, xlon, pphis, pphi, &
             t_seri, pplay, paprs, sh , &
-            tr_seri, solsym)
+            tr_seri)
 
     END SELECT
Index: LMDZ5/trunk/libf/phylmd/rrtm/readaerosol_optic_rrtm.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/rrtm/readaerosol_optic_rrtm.F90	(revision 2179)
+++ LMDZ5/trunk/libf/phylmd/rrtm/readaerosol_optic_rrtm.F90	(revision 2180)
@@ -84,6 +84,5 @@
   REAL, DIMENSION(klon,klev,naero_tot) :: m_allaer
   REAL, DIMENSION(klon,klev,naero_tot) :: m_allaer_pi !RAF  
-  !  REAL, DIMENSION(klon,naero_tot)      :: fractnat_allaer !RAF delete??
-  character(len=8), dimension(nbtr) :: tracname
+
   integer :: id_ASBCM, id_ASPOMM, id_ASSO4M, id_ASMSAM, id_CSSO4M, id_CSMSAM, id_SSSSM
   integer :: id_CSSSM, id_ASSSM, id_CIDUSTM, id_AIBCM, id_AIPOMM, id_ASNO3M, id_CSNO3M, id_CINO3M
@@ -104,10 +103,6 @@
      !--convert to ug m-3 unit for consistency with offline fields
      !
-#ifdef INCA
-     call tracinca_name(tracname)
-#endif
-
      do i=1,nbtr
-        select case(trim(tracname(i)))
+        select case(trim(solsym(i)))
            case ("ASBCM")
               id_ASBCM = i
Index: LMDZ5/trunk/libf/phylmd/tracinca_mod.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/tracinca_mod.F90	(revision 2179)
+++ LMDZ5/trunk/libf/phylmd/tracinca_mod.F90	(revision 2180)
@@ -35,5 +35,5 @@
        tau_aero, piz_aero, cg_aero,        ccm,       &
        rfname,                                        &
-       tr_seri,  source,   solsym)      
+       tr_seri,  source)      
 
 !========================================================
@@ -113,5 +113,4 @@
   ! Output arguments
     REAL,DIMENSION(klon,nbtr), INTENT(OUT)        :: source  ! a voir lorsque le flux de surface est prescrit 
-    CHARACTER(len=8),DIMENSION(nbtr), INTENT(OUT) :: solsym
 
 !=======================================================================================
@@ -134,30 +133,20 @@
        pdel(:,k) = paprs(:,k) - paprs (:,k+1)
     END DO
-    
-    zpmfu(:,:)=pmfu(:,:)
+  
+#ifdef INCA
+    IF (config_inca == 'aero') THEN 
+       zpmfu(:,:)=pmfu(:,:)       
+    ELSE IF (config_inca == 'aeNP') THEN
+       zpmfu(:,:)=upwd(:,:)
+    ENDIF
 
-    IF (config_inca == 'aero') THEN
-#ifdef INCA
-       CALL aerosolmain(                    &
-            aerosol_couple,tr_seri,pdtphys, &
-            pplay,pdel,prfl,pmflxr,psfl,    &
-            pmflxs,zpmfu,itop_con,ibas_con,  &
-            pphi,airephy,nstep,rneb,t_seri, &      
-            rh,tau_aero,piz_aero,cg_aero,   &
-            rfname,ccm,lafin)
+    CALL aerosolmain(                    &
+         aerosol_couple,tr_seri,pdtphys, &
+         pplay,pdel,prfl,pmflxr,psfl,    &
+         pmflxs,zpmfu,itop_con,ibas_con,  &
+         pphi,airephy,nstep,rneb,t_seri, &      
+         rh,tau_aero,piz_aero,cg_aero,   &
+         rfname,ccm,lafin, config_inca)
 #endif
-    END IF
-
-    IF (config_inca == 'aeNP') THEN
-#ifdef INCA
-       zpmfu(:,:)=upwd(:,:)
-       CALL aerosolmainNP(                  &
-            aerosol_couple,tr_seri,pdtphys, &
-            pplay,pdel,prfl,pmflxr,psfl,    &
-            pmflxs,zpmfu,itop_con,ibas_con,  &
-            pphi,airephy,nstep,rneb,t_seri, &      
-            rh,lafin)
-#endif
-    END IF
 
 
@@ -196,6 +185,5 @@
          iip1,       & !nx
          jjp1,       & !ny
-         source,     &
-         solsym)
+         source )
 #endif
     
Index: LMDZ5/trunk/libf/phylmd/traclmdz_mod.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/traclmdz_mod.F90	(revision 2179)
+++ LMDZ5/trunk/libf/phylmd/traclmdz_mod.F90	(revision 2180)
@@ -338,6 +338,5 @@
        cdragh,  coefh, yu1, yv1, ftsol, pctsrf, xlat, xlon, couchelimite, sh, &
        rh, pphi, ustar, wstar, ale_bl, ale_wake,  zu10m, zv10m, &
-!!          tr_seri, source, solsym, d_tr_cl, zmasse)                      !RomP
-          tr_seri, source, solsym, d_tr_cl,d_tr_dec, zmasse)               !RomP
+       tr_seri, source, d_tr_cl,d_tr_dec, zmasse)               !RomP
     
     USE dimphy
@@ -397,5 +396,4 @@
 
 ! Output argument
-    CHARACTER(len=8),DIMENSION(nbtr), INTENT(OUT) :: solsym
     REAL,DIMENSION(klon,nbtr), INTENT(OUT)        :: source  ! a voir lorsque le flux de surface est prescrit 
     REAL,DIMENSION(klon,klev,nbtr), INTENT(OUT)   :: d_tr_cl ! Td couche limite/traceur
Index: LMDZ5/trunk/libf/phylmd/tracreprobus_mod.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/tracreprobus_mod.F90	(revision 2179)
+++ LMDZ5/trunk/libf/phylmd/tracreprobus_mod.F90	(revision 2180)
@@ -9,5 +9,5 @@
        presnivs, xlat, xlon, pphis, pphi, &
        t_seri, pplay, paprs, sh , &
-       tr_seri, solsym)
+       tr_seri)
 
     USE dimphy
@@ -42,5 +42,4 @@
 !----------------
     REAL,DIMENSION(klon,klev,nbtr),INTENT(INOUT)  :: tr_seri ! Concentration Traceur [U/KgA]  
-    CHARACTER(len=8),DIMENSION(nbtr), INTENT(OUT) :: solsym
   
 